Donut NES CHR Codec README
===

[Donut] is a compression codec for the native texture data of a Nintendo Entertainment System (NES). It operates by a fixed decoded block size of 64 bytes, and saves about 45% in compressed size. Compared to 47% saved by [Tokumaru's compression] but much faster.

Along with the space savings Donut decoding features real time decoding speed of about 16~32 tiles per NTSC frame and a flexible decoding address to allow direct placement in a PPU Buffer format at runtime.

Depending on the options the compressor can input:
- a raw `.chr` file in native NES texture data
- an interleaved `.chr` file were every other byte is a bitmap where 1 represents that the corresponding bit is a "don't care bit" that's allowed to flip for better compress-ability
- a PNG/GIF/BMP image with 8x8 pixel tiles arranged left to right, top to bottom without spacing. Pixels can be grayscale or NESMaker style RGB[^1] and #ff00ff represents don't care pixels
- a compressed file to decompress back into a raw `.chr` file

`donut.s` and `donut-nes.c` are released into the Public domain, please read those files for details.

[Donut]: https://jroatch.nfshost.com/donut-nes/
[Tokumaru's compression]: https://bisqwit.iki.fi/source/tokumaru.html
[^1]: Were the 4 indexes are #000000, #ff0000, #00ff00, #0000ff

## List of files

`readme.md`
: This file.

`donut.s`
: 6502 decompressor (ca65 dialect) for use in a NES project

`donut-nes.c`
: A compressor program written in C99, Read the top comment for compiler instructions

`stb_image.h`
: a [single-file C library] For image loading support in `donut-nes.c`

`donut-nes.exe`
: `donut-nes.c` precompiled with [cosmopolitan libc] for running on Windows/Linux/Mac/etc.
Always take precautions when running random executables downloaded from the internet. Backup your personal files, and logout sensitive internet sessions.

`example.chr`
: A 4096 byte example file in native NES texture data. Font is [Questalgia], and various tiles from [Generitiles] by Drag, [Cavewoman] by Sik, and [Chase] by shiru.

`example.png`
: Visual representation of `example.chr`

`example.donut`
: `example.chr` compressed with Donut

`example-a53thumbs.png`
: An example image which demonstrates the types of pixels that the compressor can process

`example-a53thumbs.xchr`
: Same as `example-a53thumbs.png` but demonstrating an interleaved `.chr` file

[single-file C library]: https://github.com/nothings/stb
[cosmopolitan libc]: https://justine.lol/cosmopolitan/
[Questalgia]: https://jroatch.nfshost.com/questalgia-font/
[Generitiles]: https://www.nesdev.org/wiki/File:Drag_-_generitiles.png
[Cavewoman]: https://www.nesdev.org/wiki/File:Sik_caveman_recolor.png
[Chase]: https://shiru.untergrund.net/articles/programming_nes_games_in_c.htm

---
By Johnathan Roatch, 2023

This text is licensed to the public under the
[Creative Commons Attribution 4.0 License][CC BY 4.0].

[CC BY 4.0]: http://creativecommons.org/licenses/by/4.0/
